unit OptKopplerMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Menus, ComCtrls,
  ExtCtrls, PairSplitter, VirtualTrees, LCLIntf, OpticalArea;

type

  { TFormMain }

  TFormMain = class(TForm)
    MainMenu: TMainMenu;
    MenuItemSafe: TMenuItem;
    MenuItemDiscretSteps: TMenuItem;
    MenuItemSettings: TMenuItem;
    MenuItemFile: TMenuItem;
    MenuItemClose: TMenuItem;
    PairSplitterMain: TPairSplitter;
    PairSplitterSideLeft: TPairSplitterSide;
    PairSplitterSideRight: TPairSplitterSide;
    PanelLeft: TPanel;
    PanelRight: TPanel;
    ScrollBoxOptAreas: TScrollBox;
    StatusBarMain: TStatusBar;
    ToolBarMain: TToolBar;
    TreeViewOptAreas: TTreeView;
    procedure FormClose(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuItemCloseClick(Sender: TObject);
    procedure MenuItemDiscretStepsClick(Sender: TObject);
    procedure MenuItemSafeClick(Sender: TObject);
    procedure ScrollBoxOptAreasDblClick(Sender: TObject);
    procedure ScrollBoxOptAreasMouseMove(Sender: TObject);
    procedure TreeViewOptAreasClick(Sender: TObject);

  private
    CrossSectionAreaList: TList;
    inReposition:         Boolean;
    oldPos :              TPoint;

  public

  end;

var
  FormMain:            TFormMain;
  CrossSectionAreaCnt: Integer;

implementation

{$R *.lfm}

{ TFormMain }

procedure TFormMain.FormCreate(Sender: TObject);
begin
  CrossSectionAreaCnt  := 0;
  CrossSectionAreaList := TList.Create;
end;

procedure TFormMain.MenuItemCloseClick(Sender: TObject);
begin
  FormMain.Close;
end;

procedure TFormMain.FormClose(Sender: TObject);
begin
  CrossSectionAreaList.Free;
end;

procedure TFormMain.MenuItemDiscretStepsClick(Sender: TObject);
begin
  ShowMessage('ToDo: Settings - X/Y Discretisations - Function');
end;

procedure TFormMain.MenuItemSafeClick(Sender: TObject);
begin
  ShowMessage('ToDo: Safe Function');
end;

procedure TFormMain.ScrollBoxOptAreasDblClick(Sender: TObject);
var
  NewOptArea: TOpticalArea;
  MousePos:   TPoint;
  x,y:        Integer;

begin
  MousePos := ScrollBoxOptAreas.ScreenToClient(Mouse.CursorPos);
  x := MousePos.x;
  y := MousePos.y;

  NewOptArea := TOpticalArea.Create(Self);
  Inc(CrossSectionAreaCnt);
  with NewOptArea do
  begin
    Parent       := ScrollBoxOptAreas;
    Left         := x;
    Top          := y;
    Pen.Color    := clBlack;
    Width        := 20;
    Height       := 20;
    Brush.Color  := clRed;
    Visible      := True;
  end;

  CrossSectionAreaList.Add(NewOptArea);
  TreeViewOptAreas.Items.Add(nil, NewOptArea.Name);

  //repaint;

end;

procedure TFormMain.ScrollBoxOptAreasMouseMove(Sender: TObject);
var
  MousePos: TPoint;
  x,y:      Integer;
begin
  MousePos := ScrollBoxOptAreas.ScreenToClient(Mouse.CursorPos);
  x := MousePos.x;
  y := MousePos.y;

  if TOpticalArea(Sender).ClassType = TOpticalArea then
    StatusBarMain.SimpleText := 'Drin in ' + TOpticalArea(Sender).Name +
       ', Left: '  + IntToStr(TOpticalArea(Sender).Left)   +
       ', Top; '   + IntToStr(TOpticalArea(Sender).Top)    +
       ', Hight: ' + IntToStr(TOpticalArea(Sender).Height) +
       ', Width: ' + IntToStr(TOpticalArea(Sender).Width)
  else
    StatusBarMain.SimpleText := 'x = ' + IntToStr(x) + ', y = ' + IntToStr(y);
end;

procedure TFormMain.TreeViewOptAreasClick(Sender: TObject);
begin
  ShowMessage('TTreeView Mouse Click');
end;

end.

